//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.3 on page
//  An AbstractQueue class

import java.util.*;
import schaums.dswj.*;

public abstract
class AbstractQueue extends AbstractCollection implements Queue
{
  protected AbstractQueue()
  { // default constructor
  }

  public abstract Object dequeue();
  // to be implemented for the Queue interface

  public abstract Object enqueue(Object object);
  // to be implemented for the Queue interface

  public boolean equals(Object object)
  { // overrides the equals() method from the Object class
    if (object == this) return true;
    if (!(object instanceof AbstractQueue)) return false;
    AbstractQueue abstractQueue = (AbstractQueue) object;
    if (abstractQueue.size() != size()) return false;
    return containsAll(abstractQueue);
  }

  public abstract Object getBack();
  // to be implemented for the Queue interface

  public abstract Object getFront();
  // to be implemented for the Queue interface

  public int hashCode()
  { // overrides the hashCode() method from the Object class
    int n = 0;
    for (Iterator it = iterator(); it.hasNext(); )
    { Object object = it.next();
      if (object != null) n += object.hashCode();
    }
    return n;
  }

  public abstract Iterator iterator();
    // inherited from the java.util.AbstractCollection class

  public abstract int size();
    // inherited from the java.util.AbstractCollection class

}

/*
  public boolean equals(Object object)
  { // returns true iff the given object is a Bag
    // and has the same content as this bag
    if (object == this) return true;
    if (object.getClass() != this.getClass()) return false;
    if (object.hashCode() != this.hashCode()) return false;
    Collection collection = (Collection)object;
    if (collection.size() != this.size()) return false;
    if (!collection.containsAll(this)) return false;
    if (!this.containsAll(collection)) return false;
    for (int i=0; i<size; i++)
    { Object x = objects[i];
      if (frequency(collection,x) != frequency(this,x))
        return false;
    }
    return true;
  }

public abstract class AbstractQueue extends AbstractCollection
                                    implements Queue
{ protected                AbstractSet()
  public          boolean  add(Object);
  public          boolean  addAll(Collection);
  public          void     clear();
  public          boolean  contains(Object);
  public          boolean  containsAll(Collection);
  public          boolean  equals(Object);
  public          int      hashCode();
  public          boolean  isEmpty();
  public abstract Iterator iterator();
  public          boolean  remove(Object);
  public          boolean  removeAll(Collection);
  public          boolean  retainAll(Collection);
  public abstract int      size();
  public          Object[] toArray();
  public          Object[] toArray(Object[]);
}
*/
