//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.7 on page
//  and Problems 7.12 and 7.13 on page 
//  A Client class for a Client/Server Simulation

public class Client
{ public static final int MEAN_JOB_SIZE = 100;
  private static Random randomJobSize = new Random(MEAN_JOB_SIZE);
  private static int nextId = 0;
  private int id, jobSize, tArrived, tBegan, tEnded;
  private Server server;

  public Client(int time)
  { id = ++nextId;
    jobSize = randomJobSize.intNextExponential();
    tArrived = time;
//    print(id,time,jobSize);
  }

  public double getJobSize()
  { return jobSize;
  }

  public int getWaitTime()
  { return tBegan - tArrived;
  }

  public int getServiceTime()
  { return tEnded - tBegan;
  }

  public void beginService(Server server, int time)
  { this.server = server;
    tBegan = time;
//    printBegins(server,id,time);
  }

  public void endService(int time)
  { tEnded = time;
//    printEnds(server,id,time);
    server = null;
  }

  public String toString()
  { return "#" + id + "(" + (int)Math.round(jobSize) + ")";
  }

  private static void print(int job, int time, double size)
  { System.out.println("Job #" + job + " arrives at time " + time
      + " with " + (int)Math.round(size) + " pages.");
  }

  private static void printBegins(Server server, int job, int time)
  { System.out.println("Printer " + server + " begins Job #" + job
      + " at time " + time + ".");
  }

  private static void printEnds(Server server, int job, int time)
  { System.out.println("Printer " + server + " ends Job #" + job
      + " at time " + time + ".");
  }
}
