//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.3 on page 124
//  An AbstractQueue class

import java.util.*;
import schaums.dswj.*;

public abstract
class AbstractQueue extends AbstractCollection implements Queue
{ 
  protected AbstractQueue() { }
  
  public abstract Object dequeue();

  public abstract Object enqueue(Object object);

  public boolean equals(Object object)
  { if (object == this) return true;
    if (!(object instanceof AbstractQueue)) return false;
    AbstractQueue abstractQueue = (AbstractQueue) object;
    if (abstractQueue.size() != size()) return false;
    return containsAll(abstractQueue);
  }

  public abstract Object getBack();

  public abstract Object getFront();

  public int hashCode()
  { int n = 0;
    for (Iterator it = iterator(); it.hasNext(); )
    { Object object = it.next();
      if (object != null) n += object.hashCode();
    }
    return n;
  }

  public abstract Iterator iterator();

  public abstract int size();

}
