//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.7 on page
//  A Client/Server Simulation

import schaums.dswj.Queue;

public class Ex0707
{ private static final int NUMBER_OF_SERVERS = 4;
  private static final double MEAN_INTERARRIVAL_TIME = 20.0;
  private static final int DURATION = 100;
  private static Server[] servers = new Server[NUMBER_OF_SERVERS];
  private static Queue clients = new ArrayQueue();
  private static Random random = new Random(MEAN_INTERARRIVAL_TIME);

  public static void main(String[] args)
  { for (int i=0; i<NUMBER_OF_SERVERS; i++)
      servers[i] = new Server();
    int timeOfNextArrival = random.intNextExponential();
    for (int t=0; t<DURATION; t++)
    { if (t == timeOfNextArrival)
      { clients.enqueue(new Client(t));
        print(clients);
        timeOfNextArrival += random.intNextExponential();
      }
      for (int i=0; i<NUMBER_OF_SERVERS; i++)
        if (servers[i].isFree())
        { if(!clients.isEmpty())
          { servers[i].beginServing((Client)clients.dequeue(),t);
            print(clients);
          }
        }
        else if (t == servers[i].getTimeServiceEnds())
          servers[i].endServing(t);
    }
  }

  private static void print(Queue queue)
  { int size=queue.size();
    if (size==0) System.out.println("The queue is now empty.");
    else System.out.println("The queue now contains " + size
           + " job" + (size>1?"s: ":": ") + queue);
  }
}
