//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.6 on page 129
//  A LinkedQueue class

import java.util.*;
import AbstractQueue;

public class LinkedQueue extends AbstractQueue
{ private static class Node
  { Object object;
    Node next, previous;
    Node()
    { this.next = this.previous = this;
    }
    Node(Object object, Node next, Node previous)
    { this.object = object;
      this.next = next;
      this.previous = previous;
    }
  }
  private Node header = new Node();
  private int size = 0;

  public Object dequeue()
  { if (isEmpty()) throw new NoSuchElementException("queue is empty");
    Object object = header.next.object;
    header.next = header.next.next;
    header.next.previous = header;
    --size;
    return object;
  }

  public Object enqueue(Object object)
  { Node p = header.previous;  // last element in queue
    header.previous = p.next = new Node(object,header,p);
    ++size;
    return object;
  }

  public Object getBack()
  { if (isEmpty()) throw new NoSuchElementException("queue is empty");
    return header.previous.object;
  }

  public Object getFront()
  { if (isEmpty()) throw new NoSuchElementException("queue is empty");
    return header.next.object;
  }

  public Iterator iterator()
  { return new Iterator()  // anonymous inner class
    { private Node cursor=header;
      public boolean hasNext()
      { return cursor.next != header;
      }
      public Object next()
      { if (cursor.next==header) throw new NoSuchElementException();
        cursor = cursor.next;
        return cursor.object;
      }
      public void remove()
      { throw new UnsupportedOperationException();
      }
    };
  }

  public LinkedQueue()
  {
  }

  public int size()
  { return size;
  }
}
