//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.7 on page
//  A Random class extension for a Client/Server Simulation

public class Random extends java.util.Random
{ private double mean;
  private double standardDeviation;

  public Random(double mean)
  { this.mean = mean;
    this.standardDeviation = mean;
  }

  public Random(double mean, double standardDeviation)
  { this.mean = mean;
    this.standardDeviation = standardDeviation;
  }

  public double nextGaussian()
  { double x = super.nextGaussian();  // x = normal(0.0, 1.0)
    return x*standardDeviation + mean;
  }
  public double nextExponential()
  { return -mean*Math.log(1.0 - nextDouble());
  }

  public int intNextExponential()
  { return (int)Math.ceil(nextExponential());
  }
}
