//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 7.7 on page and Problems 7.12 and 7.13 on page 
//  A Server class for a Client/Server Simulation

public class Server
{ private static Random randomMeanServiceRate = new Random(1.00,0.20);
  private static char nextId = 'A';
  private Random randomServiceRate;
  private char id;
  private double meanServiceRate, serviceRate;
  private Client client;
  private int timeServiceEnds;

  public Server()
  { id = (char)nextId++;
    meanServiceRate = randomMeanServiceRate.nextGaussian();
    randomServiceRate = new Random(meanServiceRate,0.10);
  }

  public Client getClient()
  { return client;
  }

  public void beginServing(Client client, int time)
  { this.client = client;
    serviceRate = randomServiceRate.nextGaussian();
    client.beginService(this,time);
    int serviceTime = (int)Math.ceil(client.getJobSize()/serviceRate);
    timeServiceEnds = time + serviceTime;
  }

  public void endServing(int time)
  { client.endService(time);
    this.client = null;
 }

  public int getTimeServiceEnds()
  { return timeServiceEnds;
  }

  public boolean isFree()
  { return client == null;
  }

  public String toString()
  { int percentMeanServiceRate = (int)Math.round(100*meanServiceRate);
    int percentServiceRate = (int)Math.round(100*serviceRate);
    return id + "(" + percentMeanServiceRate + "%,"
              + percentServiceRate + "%)";
  }
}
